
    /*!
    * structured-editor-extensions v0.1.3
    * (c) 2019 HollyIT (limited liability)
    * @license MIT
    */
  
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tiptap = require('tiptap');
var prosemirrorCommands = require('prosemirror-commands');
var structuredEditorUtils = require('@ledecmf/structured-editor-utils');
var tiptapCommands = require('tiptap-commands');
var prosemirrorSchemaList = require('prosemirror-schema-list');
var tiptapUtils = require('tiptap-utils');
var script = require('LinkButton.vue?rollup-plugin-vue=script.js');
var script__default = _interopDefault(script);
var __vue_normalize__ = _interopDefault(require('vue-runtime-helpers/dist/normalize-component.js'));
var __vue_create_injector__ = _interopDefault(require('vue-runtime-helpers/dist/inject-style/browser.js'));
var prosemirrorUtils = require('prosemirror-utils');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var Node =
/*#__PURE__*/
function (_BaseNode) {
  _inherits(Node, _BaseNode);

  function Node() {
    _classCallCheck(this, Node);

    return _possibleConstructorReturn(this, _getPrototypeOf(Node).apply(this, arguments));
  }

  _createClass(Node, [{
    key: "isAvailable",
    value: function isAvailable(editor, attrs) {
      var state = editor.state;
      var type = state.schema.nodes[this.name];

      if (!type) {
        return true;
      }

      return prosemirrorCommands.setBlockType(type, attrs)(state);
    }
  }, {
    key: "icon",
    get: function get() {
      return this.name;
    }
  }, {
    key: "label",
    get: function get() {
      return structuredEditorUtils.nameToLabel(this.name);
    }
  }]);

  return Node;
}(tiptap.Node);

var Doc =
/*#__PURE__*/
function (_Node) {
  _inherits(Doc, _Node);

  function Doc() {
    _classCallCheck(this, Doc);

    return _possibleConstructorReturn(this, _getPrototypeOf(Doc).apply(this, arguments));
  }

  _createClass(Doc, [{
    key: "name",
    get: function get() {
      return 'doc';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        content: 'block+'
      };
    }
  }]);

  return Doc;
}(tiptap.Node);

var Paragraph =
/*#__PURE__*/
function (_Node) {
  _inherits(Paragraph, _Node);

  function Paragraph() {
    _classCallCheck(this, Paragraph);

    return _possibleConstructorReturn(this, _getPrototypeOf(Paragraph).apply(this, arguments));
  }

  _createClass(Paragraph, [{
    key: "blockTypes",
    value: function blockTypes() {
      return true;
    }
  }, {
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type;
      return function () {
        return tiptapCommands.setBlockType(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'paragraph';
    }
  }, {
    key: "menu",
    get: function get() {
      return 'selection';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        content: 'inline*',
        group: 'block',
        draggable: false,
        parseDOM: [{
          tag: 'p'
        }],
        toDOM: function toDOM(node) {
          return ['p', 0];
        }
      };
    }
  }]);

  return Paragraph;
}(Node);

var Text =
/*#__PURE__*/
function (_Node) {
  _inherits(Text, _Node);

  function Text() {
    _classCallCheck(this, Text);

    return _possibleConstructorReturn(this, _getPrototypeOf(Text).apply(this, arguments));
  }

  _createClass(Text, [{
    key: "name",
    get: function get() {
      return 'text';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        group: 'inline'
      };
    }
  }]);

  return Text;
}(tiptap.Node);

var ListItem =
/*#__PURE__*/
function (_Node) {
  _inherits(ListItem, _Node);

  function ListItem() {
    _classCallCheck(this, ListItem);

    return _possibleConstructorReturn(this, _getPrototypeOf(ListItem).apply(this, arguments));
  }

  _createClass(ListItem, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      return {
        Enter: tiptapCommands.splitListItem(type),
        Tab: tiptapCommands.sinkListItem(type),
        'Shift-Tab': tiptapCommands.liftListItem(type)
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'list_item';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        content: 'paragraph block*',
        defining: true,
        draggable: false,
        parseDOM: [{
          tag: 'li'
        }],
        toDOM: function toDOM() {
          return ['li', 0];
        }
      };
    }
  }]);

  return ListItem;
}(Node);

var BulletList =
/*#__PURE__*/
function (_Node) {
  _inherits(BulletList, _Node);

  function BulletList() {
    _classCallCheck(this, BulletList);

    return _possibleConstructorReturn(this, _getPrototypeOf(BulletList).apply(this, arguments));
  }

  _createClass(BulletList, [{
    key: "isAvailable",
    value: function isAvailable(editor) {
      var state = editor.state;
      var fn = prosemirrorSchemaList.wrapInList(state.schema.nodes.bullet_list);
      return fn(state);
    }
  }, {
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type,
          schema = _ref.schema;
      return function () {
        return tiptapCommands.toggleList(type, schema.nodes.list_item);
      };
    }
  }, {
    key: "keys",
    value: function keys(_ref2) {
      var type = _ref2.type,
          schema = _ref2.schema;
      return {
        'Shift-Ctrl-8': tiptapCommands.toggleList(type, schema.nodes.list_item)
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'bullet_list';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        content: 'list_item+',
        group: 'block',
        parseDOM: [{
          tag: 'ul'
        }],
        toDOM: function toDOM() {
          return ['ul', 0];
        }
      };
    }
  }, {
    key: "dependencies",
    get: function get() {
      return [new ListItem()];
    }
  }]);

  return BulletList;
}(Node);

var HardBreak =
/*#__PURE__*/
function (_Node) {
  _inherits(HardBreak, _Node);

  function HardBreak() {
    _classCallCheck(this, HardBreak);

    return _possibleConstructorReturn(this, _getPrototypeOf(HardBreak).apply(this, arguments));
  }

  _createClass(HardBreak, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      var command = tiptapCommands.chainCommands(tiptapCommands.exitCode, function (state, dispatch) {
        dispatch(state.tr.replaceSelectionWith(type.create()).scrollIntoView());
        return true;
      });
      return {
        'Mod-Enter': command,
        'Shift-Enter': command
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'hard_break';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        inline: true,
        group: 'inline',
        selectable: false,
        parseDOM: [{
          tag: 'br'
        }],
        toDOM: function toDOM() {
          return ['br'];
        }
      };
    }
  }]);

  return HardBreak;
}(Node);

var HorizontalRule =
/*#__PURE__*/
function (_Node) {
  _inherits(HorizontalRule, _Node);

  function HorizontalRule() {
    _classCallCheck(this, HorizontalRule);

    return _possibleConstructorReturn(this, _getPrototypeOf(HorizontalRule).apply(this, arguments));
  }

  _createClass(HorizontalRule, [{
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type;
      return function () {
        return function (state, dispatch) {
          return dispatch(state.tr.replaceSelectionWith(type.create()));
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'horizontal_rule';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'hr';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        group: 'block',
        parseDOM: [{
          tag: 'hr'
        }],
        toDOM: function toDOM() {
          return ['hr'];
        }
      };
    }
  }]);

  return HorizontalRule;
}(Node);

var Image =
/*#__PURE__*/
function (_Node) {
  _inherits(Image, _Node);

  function Image() {
    _classCallCheck(this, Image);

    return _possibleConstructorReturn(this, _getPrototypeOf(Image).apply(this, arguments));
  }

  _createClass(Image, [{
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type;
      return function (attrs) {
        return function (state, dispatch) {
          var selection = state.selection;
          var position = selection.$cursor ? selection.$cursor.pos : selection.$to.pos;
          var node = type.create(attrs);
          var transaction = state.tr.insert(position, node);
          dispatch(transaction);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'image';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        inline: true,
        attrs: {
          src: {},
          alt: {
            default: null
          },
          title: {
            default: null
          }
        },
        group: 'inline',
        draggable: true,
        selectable: true,
        parseDOM: [{
          tag: 'img[src]',
          getAttrs: function getAttrs(dom) {
            return {
              src: dom.getAttribute('src'),
              title: dom.getAttribute('title'),
              alt: dom.getAttribute('alt')
            };
          }
        }],
        toDOM: function toDOM(node) {
          var _node$attrs = node.attrs,
              src = _node$attrs.src,
              alt = _node$attrs.alt,
              title = _node$attrs.title;
          return ["img", {
            src: src,
            alt: alt,
            title: title
          }];
        }
      };
    }
  }]);

  return Image;
}(Node);

var OrderedList =
/*#__PURE__*/
function (_Node) {
  _inherits(OrderedList, _Node);

  function OrderedList() {
    _classCallCheck(this, OrderedList);

    return _possibleConstructorReturn(this, _getPrototypeOf(OrderedList).apply(this, arguments));
  }

  _createClass(OrderedList, [{
    key: "isAvailable",
    value: function isAvailable(_ref) {
      var state = _ref.state;
      var fn = prosemirrorSchemaList.wrapInList(state.schema.nodes.ordered_list);
      return fn(state);
    }
  }, {
    key: "commands",
    value: function commands(_ref2) {
      var type = _ref2.type,
          schema = _ref2.schema;
      return function () {
        return tiptapCommands.toggleList(type, schema.nodes.list_item);
      };
    }
  }, {
    key: "keys",
    value: function keys(_ref3) {
      var type = _ref3.type,
          schema = _ref3.schema;
      return {
        'Shift-Ctrl-9': tiptapCommands.toggleList(type, schema.nodes.list_item)
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'ordered_list';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        attrs: {
          order: {
            default: 1
          }
        },
        content: 'list_item+',
        group: 'block',
        parseDOM: [{
          tag: 'ol',
          getAttrs: function getAttrs(dom) {
            return {
              order: dom.hasAttribute('start') ? +dom.getAttribute('start') : 1
            };
          }
        }],
        toDOM: function toDOM(node) {
          return node.attrs.order === 1 ? ['ol', 0] : ['ol', {
            start: node.attrs.order
          }, 0];
        }
      };
    }
  }, {
    key: "dependencies",
    get: function get() {
      return [new ListItem()];
    }
  }]);

  return OrderedList;
}(Node);

var _default =
/*#__PURE__*/
function (_Node) {
  _inherits(_default, _Node);

  function _default() {
    _classCallCheck(this, _default);

    return _possibleConstructorReturn(this, _getPrototypeOf(_default).apply(this, arguments));
  }

  _createClass(_default, [{
    key: "blockTypes",
    value: function blockTypes(typeMenu) {
      this.options.levels.forEach(function (level) {
        typeMenu.add('heading ' + level, 'heading', {
          level: level
        });
      });
    }
  }, {
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type;
      return function (attrs) {
        return tiptapCommands.setBlockType(type, attrs);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'heading';
    }
  }, {
    key: "defaultOptions",
    get: function get() {
      return {
        levels: [2, 3, 4, 5]
      };
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        attrs: {
          level: {
            default: 2
          }
        },
        content: 'text*',
        marks: '',
        group: 'block',
        defining: true,
        draggable: false,
        parseDOM: this.options.levels.map(function (level) {
          return {
            tag: "h".concat(level),
            attrs: {
              level: level
            }
          };
        }),
        toDOM: function toDOM(node) {
          return ["h".concat(node.attrs.level), 0];
        }
      };
    }
  }]);

  return _default;
}(Node);

var Blockquote =
/*#__PURE__*/
function (_Node) {
  _inherits(Blockquote, _Node);

  function Blockquote() {
    _classCallCheck(this, Blockquote);

    return _possibleConstructorReturn(this, _getPrototypeOf(Blockquote).apply(this, arguments));
  }

  _createClass(Blockquote, [{
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type,
          schema = _ref.schema;
      return function () {
        return tiptapCommands.wrapIn(type, schema.nodes.paragraph);
      };
    }
  }, {
    key: "keys",
    value: function keys(_ref2) {
      var type = _ref2.type;
      return {
        'Ctrl->': tiptapCommands.toggleWrap(type)
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'blockquote';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        content: "block+",
        group: "block",
        defining: true,
        draggable: false,
        attrs: {
          citation: {
            default: ''
          },
          citation_url: {
            default: ''
          }
        },
        parseDOM: [{
          tag: "blockquote"
        }],
        toDOM: function toDOM() {
          return ['blockquote', 0];
        }
      };
    }
  }]);

  return Blockquote;
}(Node);

var Mark =
/*#__PURE__*/
function (_BaseMark) {
  _inherits(Mark, _BaseMark);

  function Mark() {
    _classCallCheck(this, Mark);

    return _possibleConstructorReturn(this, _getPrototypeOf(Mark).apply(this, arguments));
  }

  _createClass(Mark, [{
    key: "icon",
    get: function get() {
      return this.name;
    }
  }, {
    key: "label",
    get: function get() {
      return structuredEditorUtils.nameToLabel(this.name);
    }
  }]);

  return Mark;
}(tiptap.Mark);

/* script */
const __vue_script__ = script__default;

/* template */
var __vue_render__ = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "div",
    { staticClass: "link-button" },
    [
      _c(
        "menu-drop-button",
        {
          ref: "button",
          attrs: { item: _vm.item, editor: _vm.editor },
          on: { opened: _vm.onOpen }
        },
        [
          _c("input", {
            directives: [
              {
                name: "model",
                rawName: "v-model",
                value: _vm.href,
                expression: "href"
              }
            ],
            ref: "input",
            attrs: { type: "text", placeholder: "http://" },
            domProps: { value: _vm.href },
            on: {
              keydown: function($event) {
                if (!$event.type.indexOf("key") && $event.keyCode !== 13) {
                  return null
                }
                $event.preventDefault();
                return _vm.insert($event)
              },
              input: function($event) {
                if ($event.target.composing) {
                  return
                }
                _vm.href = $event.target.value;
              }
            }
          }),
          _vm._v(" "),
          _c("editor-button", {
            attrs: { icon: "check" },
            on: { click: _vm.insert }
          }),
          _vm._v(" "),
          _vm.href
            ? _c("editor-button", {
                attrs: { icon: "trash" },
                on: { click: _vm.trash }
              })
            : _vm._e()
        ],
        1
      )
    ],
    1
  )
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = function (inject) {
    if (!inject) return
    inject("data-v-55079ad0_0", { source: ".link-option-dialog {\n  display: flex;\n}\n.code-toolbar .delete-link {\n  display: none;\n}\n\n/*# sourceMappingURL=LinkButton.vue.map */", map: {"version":3,"sources":["/mnt/z/client/LedeCMF/temp/editor-structured/packages/structured-editor-extensions/src/Marks/components/LinkButton.vue","LinkButton.vue"],"names":[],"mappings":"AAmFA;EACA,aAAA;AClFA;ADqFA;EACA,aAAA;AClFA;;AAEA,yCAAyC","file":"LinkButton.vue","sourcesContent":["<template>\n    <div class=\"link-button\">\n        <menu-drop-button :item=\"item\" :editor=\"editor\" @opened=\"onOpen\" ref=\"button\">\n            <input type=\"text\" placeholder=\"http://\" ref=\"input\" @keydown.13.prevent=\"insert\" v-model=\"href\">\n            <editor-button icon=\"check\" @click=\"insert\"></editor-button>\n            <editor-button v-if=\"href\" icon=\"trash\" @click=\"trash\"></editor-button>\n        </menu-drop-button>\n    </div>\n\n\n</template>\n\n<script>\n    import {EditorButton} from '@ledecmf/editor-core'\n    import {MenuDropButton} from '@ledecmf/structured-editor-ui'\n    export default {\n        name: 'LinkButton',\n        components: {MenuDropButton, EditorButton},\n        props: {\n            item: Object,\n            editor: Object,\n            showLabel: Boolean\n        },\n        inject: ['$editor'],\n        data() {\n            return {\n                href: '',\n                opened: false,\n                href: ''\n            }\n        },\n\n        watch: {\n            menuActive(val) {\n                if (!val) {\n                    this.opened = false\n                }\n            },\n        },\n\n        methods: {\n            insert() {\n                this.item.command(this.editor, {href: this.href});\n                this.$refs.button.close();\n\n            },\n            onOpen() {\n                let attrs = this.editor.getMarkAttrs('link');\n                this.href = attrs && attrs.href ? attrs.href : '';\n                this.$nextTick(() => {\n                    this.$refs.input.focus();\n                })\n\n            },\n            trash() {\n                this.href = '';\n                this.item.command(this.editor, {href: this.href});\n                this.$refs.button.close();\n            },\n\n            toggleOpened() {\n                if (this.opened) {\n                    this.close()\n                } else {\n                    this.open()\n                }\n            },\n\n            open() {\n                let attrs = this.editor.getMarkAttrs ? this.editor.getMarkAttrs('link') : {}\n                this.href = attrs ? attrs.href : ''\n                this.opened = true\n            },\n\n            close() {\n                this.opened = false\n            },\n\n        },\n    }\n</script>\n\n<style lang=\"scss\">\n    .link-option-dialog {\n        display: flex;\n    }\n\n    .code-toolbar .delete-link {\n        display: none;\n    }\n\n\n</style>\n",".link-option-dialog {\n  display: flex;\n}\n\n.code-toolbar .delete-link {\n  display: none;\n}\n\n/*# sourceMappingURL=LinkButton.vue.map */"]}, media: undefined });

  };
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject SSR */
  

  
  var LinkButton = __vue_normalize__(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    __vue_create_injector__,
    undefined
  );

var Link =
/*#__PURE__*/
function (_Mark) {
  _inherits(Link, _Mark);

  function Link() {
    _classCallCheck(this, Link);

    return _possibleConstructorReturn(this, _getPrototypeOf(Link).apply(this, arguments));
  }

  _createClass(Link, [{
    key: "commands",
    value: function commands(_ref) {
      var type = _ref.type;
      return function (attrs) {
        if (attrs.href) {
          return tiptapCommands.updateMark(type, attrs);
        }

        return tiptapCommands.removeMark(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'link';
    }
  }, {
    key: "menu",
    get: function get() {
      return LinkButton;
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        attrs: {
          href: {
            default: null
          }
        },
        inclusive: false,
        parseDOM: [{
          tag: 'a[href]',
          getAttrs: function getAttrs(dom) {
            return {
              href: dom.getAttribute('href')
            };
          }
        }],
        toDOM: function toDOM(node) {
          return ['a', _objectSpread({
            target: '_blank'
          }, node.attrs), 0];
        }
      };
    }
  }, {
    key: "button",
    get: function get() {
      return LinkButton;
    }
  }, {
    key: "plugins",
    get: function get() {
      return [new tiptap.Plugin({
        props: {
          handleClick: function handleClick(view, pos) {
            var _view$state = view.state,
                schema = _view$state.schema,
                doc = _view$state.doc,
                tr = _view$state.tr;
            var range = tiptapUtils.getMarkRange(doc.resolve(pos), schema.marks.link);

            if (!range) {
              return;
            }

            var $start = doc.resolve(range.from);
            var $end = doc.resolve(range.to);
            var transaction = tr.setSelection(new tiptap.TextSelection($start, $end));
            view.dispatch(transaction);
          }
        }
      })];
    }
  }]);

  return Link;
}(Mark);

var Bold =
/*#__PURE__*/
function (_Mark) {
  _inherits(Bold, _Mark);

  function Bold() {
    _classCallCheck(this, Bold);

    return _possibleConstructorReturn(this, _getPrototypeOf(Bold).apply(this, arguments));
  }

  _createClass(Bold, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      return {
        'Mod-b': tiptapCommands.toggleMark(type)
      };
    }
  }, {
    key: "commands",
    value: function commands(_ref2) {
      var type = _ref2.type;
      return function () {
        return tiptapCommands.toggleMark(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'bold';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        parseDOM: [{
          tag: 'strong'
        }, {
          tag: 'b',
          getAttrs: function getAttrs(node) {
            return node.style.fontWeight !== 'normal' && null;
          }
        }, {
          style: 'font-weight',
          getAttrs: function getAttrs(value) {
            return /^(bold(er)?|[5-9]\d{2,})$/.test(value) && null;
          }
        }],
        toDOM: function toDOM() {
          return ['strong', 0];
        }
      };
    }
  }]);

  return Bold;
}(Mark);

var Italic =
/*#__PURE__*/
function (_Mark) {
  _inherits(Italic, _Mark);

  function Italic() {
    _classCallCheck(this, Italic);

    return _possibleConstructorReturn(this, _getPrototypeOf(Italic).apply(this, arguments));
  }

  _createClass(Italic, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      return {
        'Mod-i': tiptapCommands.toggleMark(type)
      };
    }
  }, {
    key: "commands",
    value: function commands(_ref2) {
      var type = _ref2.type;
      return function () {
        return tiptapCommands.toggleMark(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'italic';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        parseDOM: [{
          tag: 'i'
        }, {
          tag: 'em'
        }, {
          style: 'font-style=italic'
        }],
        toDOM: function toDOM() {
          return ['em', 0];
        }
      };
    }
  }]);

  return Italic;
}(Mark);

var Strike =
/*#__PURE__*/
function (_Mark) {
  _inherits(Strike, _Mark);

  function Strike() {
    _classCallCheck(this, Strike);

    return _possibleConstructorReturn(this, _getPrototypeOf(Strike).apply(this, arguments));
  }

  _createClass(Strike, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      return {
        'Mod-d': tiptapCommands.toggleMark(type)
      };
    }
  }, {
    key: "commands",
    value: function commands(_ref2) {
      var type = _ref2.type;
      return function () {
        return tiptapCommands.toggleMark(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'strike';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        parseDOM: [{
          tag: 's'
        }, {
          tag: 'del'
        }, {
          tag: 'strike'
        }, {
          style: 'text-decoration',
          getAttrs: function getAttrs(value) {
            return value === 'line-through';
          }
        }],
        toDOM: function toDOM() {
          return ['del', 0];
        }
      };
    }
  }]);

  return Strike;
}(Mark);

var Underline =
/*#__PURE__*/
function (_Mark) {
  _inherits(Underline, _Mark);

  function Underline() {
    _classCallCheck(this, Underline);

    return _possibleConstructorReturn(this, _getPrototypeOf(Underline).apply(this, arguments));
  }

  _createClass(Underline, [{
    key: "keys",
    value: function keys(_ref) {
      var type = _ref.type;
      return {
        'Mod-u': tiptapCommands.toggleMark(type)
      };
    }
  }, {
    key: "commands",
    value: function commands(_ref2) {
      var type = _ref2.type;
      return function () {
        return tiptapCommands.toggleMark(type);
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'underline';
    }
  }, {
    key: "schema",
    get: function get() {
      return {
        parseDOM: [{
          tag: 'u'
        }, {
          style: 'text-decoration',
          getAttrs: function getAttrs(value) {
            return value === 'underline';
          }
        }],
        toDOM: function toDOM() {
          return ['u', 0];
        }
      };
    }
  }]);

  return Underline;
}(Mark);

var Extension =
/*#__PURE__*/
function (_BaseExtension) {
  _inherits(Extension, _BaseExtension);

  function Extension() {
    _classCallCheck(this, Extension);

    return _possibleConstructorReturn(this, _getPrototypeOf(Extension).apply(this, arguments));
  }

  _createClass(Extension, [{
    key: "isAvailable",
    value: function isAvailable(state) {
      return true;
    }
  }, {
    key: "icon",
    get: function get() {
      return this.name;
    }
  }, {
    key: "label",
    get: function get() {
      return structuredEditorUtils.nameToLabel(this.name);
    }
  }]);

  return Extension;
}(tiptap.Extension);

var CleanFormat =
/*#__PURE__*/
function (_Extension) {
  _inherits(CleanFormat, _Extension);

  function CleanFormat() {
    _classCallCheck(this, CleanFormat);

    return _possibleConstructorReturn(this, _getPrototypeOf(CleanFormat).apply(this, arguments));
  }

  _createClass(CleanFormat, [{
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch, view) {};
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'clean_format';
    }
  }]);

  return CleanFormat;
}(Extension);

var MergeBlock =
/*#__PURE__*/
function (_Extension) {
  _inherits(MergeBlock, _Extension);

  function MergeBlock() {
    _classCallCheck(this, MergeBlock);

    return _possibleConstructorReturn(this, _getPrototypeOf(MergeBlock).apply(this, arguments));
  }

  _createClass(MergeBlock, [{
    key: "isActive",
    value: function isActive() {
      return false;
    }
  }, {
    key: "isAvailable",
    value: function isAvailable(editor) {
      return prosemirrorCommands.joinUp(editor.state);
    }
  }, {
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch) {
          return prosemirrorCommands.joinUp(state, dispatch);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'merge_block';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'merge';
    }
  }]);

  return MergeBlock;
}(Extension);

var LiftBlock =
/*#__PURE__*/
function (_Extension) {
  _inherits(LiftBlock, _Extension);

  function LiftBlock() {
    _classCallCheck(this, LiftBlock);

    return _possibleConstructorReturn(this, _getPrototypeOf(LiftBlock).apply(this, arguments));
  }

  _createClass(LiftBlock, [{
    key: "isActive",
    value: function isActive() {
      return false;
    }
  }, {
    key: "isAvailable",
    value: function isAvailable(editor) {
      return prosemirrorCommands.lift(editor.state);
    }
  }, {
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch, view) {
          return prosemirrorCommands.lift(state, dispatch);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'lift_block';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'outdent';
    }
  }]);

  return LiftBlock;
}(Extension);

var SelectParentNode =
/*#__PURE__*/
function (_Extension) {
  _inherits(SelectParentNode, _Extension);

  function SelectParentNode() {
    _classCallCheck(this, SelectParentNode);

    return _possibleConstructorReturn(this, _getPrototypeOf(SelectParentNode).apply(this, arguments));
  }

  _createClass(SelectParentNode, [{
    key: "isActive",
    value: function isActive() {
      return false;
    }
  }, {
    key: "isAvailable",
    value: function isAvailable(editor) {
      return prosemirrorCommands.selectParentNode(editor.state);
    }
  }, {
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch, view) {
          return prosemirrorCommands.selectParentNode(state, dispatch, view);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'select_parent_block';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'select_up';
    }
  }]);

  return SelectParentNode;
}(Extension);

var InsertAbove =
/*#__PURE__*/
function (_Extension) {
  _inherits(InsertAbove, _Extension);

  function InsertAbove() {
    _classCallCheck(this, InsertAbove);

    return _possibleConstructorReturn(this, _getPrototypeOf(InsertAbove).apply(this, arguments));
  }

  _createClass(InsertAbove, [{
    key: "isActive",
    value: function isActive() {
      return false;
    }
  }, {
    key: "isAvailable",
    value: function isAvailable(editor) {
      return true;
    }
  }, {
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch, view) {
          var tr = state.tr;
 // If we're on an embedded node, we need to work up the tree
          // to the top node and get the position info from that.

          var predicate = function predicate(node) {
            if (depth < 2) {
              return true;
            }

            depth--;
          };

          var depth = state.selection.$from.depth;
          var parent = prosemirrorUtils.findParentNode(predicate)(state.selection);
          var pos = parent ? parent.start - 1 : state.selection.$from.pos;
          tr.insert(pos, state.config.schema.nodes.paragraph.createAndFill());
          view.dispatch(tr);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'insert_above';
    }
  }, {
    key: "label",
    get: function get() {
      return 'Insert block above';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'insert_above';
    }
  }]);

  return InsertAbove;
}(Extension);

var InsertBelow =
/*#__PURE__*/
function (_Extension) {
  _inherits(InsertBelow, _Extension);

  function InsertBelow() {
    _classCallCheck(this, InsertBelow);

    return _possibleConstructorReturn(this, _getPrototypeOf(InsertBelow).apply(this, arguments));
  }

  _createClass(InsertBelow, [{
    key: "isActive",
    value: function isActive() {
      return false;
    }
  }, {
    key: "isAvailable",
    value: function isAvailable(editor) {
      return true;
    }
  }, {
    key: "commands",
    value: function commands() {
      return function () {
        return function (state, dispatch, view) {
          var tr = state.tr; // If we're on an embedded node, we need to work up the tree
          // to the top node and get the position info from that.

          var predicate = function predicate() {
            if (depth < 2) {
              return true;
            }

            depth--;
          };

          var depth = state.selection.$from.depth;
          var parent = prosemirrorUtils.findParentNode(predicate)(state.selection);
          var newPos = state.selection.$from.pos + 1;

          if (parent) {
            newPos = parent.start + parent.node.nodeSize - 1;
          }

          tr.insert(newPos, state.config.schema.nodes.paragraph.createAndFill());
          view.dispatch(tr);
        };
      };
    }
  }, {
    key: "name",
    get: function get() {
      return 'insert_below';
    }
  }, {
    key: "label",
    get: function get() {
      return 'Insert block below';
    }
  }, {
    key: "icon",
    get: function get() {
      return 'insert_below';
    }
  }]);

  return InsertBelow;
}(Extension);

exports.Blockquote = Blockquote;
exports.Bold = Bold;
exports.BulletList = BulletList;
exports.CleanFormat = CleanFormat;
exports.Doc = Doc;
exports.Extension = Extension;
exports.HardBreak = HardBreak;
exports.Heading = _default;
exports.HorizontalRule = HorizontalRule;
exports.Image = Image;
exports.InsertAbove = InsertAbove;
exports.InsertBelow = InsertBelow;
exports.Italic = Italic;
exports.LiftBlock = LiftBlock;
exports.Link = Link;
exports.ListItem = ListItem;
exports.Mark = Mark;
exports.MergeBlock = MergeBlock;
exports.Node = Node;
exports.OrderedList = OrderedList;
exports.Paragraph = Paragraph;
exports.SelectParentNode = SelectParentNode;
exports.Strike = Strike;
exports.Text = Text;
exports.Underline = Underline;
